class MyKick expands Keypoint;

var MBot_D Pending;
var Vector Direction;
var float Distance, LastKickTime;
var int JumpZ;
var Vector StartLocation;
var bool bDemanded;

event PreBeginPlay()
{
	// No relevance shite
}

event PostBeginPlay()
{
	StartLocation = Location;
	if ( Pawn(Owner) != None )
		JumpZ=Pawn(Owner).JumpZ;
}

event Timer()
{
	if ( Pending != None
		&& Pending.Health >= 1
			&& Pending.MoveTarget != None
				&& !Pending.bCamping )
	{
		SetRotation(Pending.Rotation); //adjust rotation of jump based on Owner
		Pending.SetPhysics(PHYS_Falling);
		if ( Pending.Region.Zone.ZoneGravity == class'ZoneInfo'.default.ZoneGravity )
			Pending.Velocity.Z = Clamp(JumpZ*FRand(),300,JumpZ);
		else
			Pending.Velocity.Z = Clamp(JumpZ,100,JumpZ/2);
		Pending.Destination = Pending.MoveTarget.Location;
		Pending.bJumpOffPawn = True;
		Pending.SetFall();
	}
	SetLocation(StartLocation); //Do party and move at home
	bDemanded = False;
}

function Touch( actor Other )
{
	if ( Other == Owner && MBot_D(Owner) != None && MBot_D(Owner).FindInventoryType(class 'UT_JumpBoots') != None )
		bDemanded=False;
	if ( Other == Owner
		&& MBot_D(Other) != None
			&& !MBot_D(Other).bHidden
				&& !Level.Game.bGameEnded
					&& !Owner.Region.Zone.bWaterZone
						&& MBot_D(Owner).IsInState('Roaming')
							&& bDemanded )
	{
		if ( LastKickTime + 3 > Level.TimeSeconds )
		{
			Pending = MBot_D(Other);
			SetTimer(0.15, false);
			LastKickTime = Level.TimeSeconds;
//			log (Self$" > I'm gonna throw "$Other.GetHumanName());
		}
		else
		{
			SetLocation(StartLocation);
			bDemanded = False;
		}
	}
}

defaultproperties
{
   bDirectional=True
   JumpZ=320
   CollisionHeight=20
   CollisionRadius=20
   RemoteRole=ROLE_None
   bStatic=False
}
